#pragma clang diagnostic ignored "-Wmissing-prototypes"
#pragma clang diagnostic ignored "-Wmissing-braces"

#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

template<typename T, size_t Num>
struct spvUnsafeArray
{
    T elements[Num ? Num : 1];
    
    thread T& operator [] (size_t pos) thread
    {
        return elements[pos];
    }
    constexpr const thread T& operator [] (size_t pos) const thread
    {
        return elements[pos];
    }
    
    device T& operator [] (size_t pos) device
    {
        return elements[pos];
    }
    constexpr const device T& operator [] (size_t pos) const device
    {
        return elements[pos];
    }
    
    constexpr const constant T& operator [] (size_t pos) const constant
    {
        return elements[pos];
    }
    
    threadgroup T& operator [] (size_t pos) threadgroup
    {
        return elements[pos];
    }
    constexpr const threadgroup T& operator [] (size_t pos) const threadgroup
    {
        return elements[pos];
    }
};

// Implementation of the GLSL mod() function, which is slightly different than Metal fmod()
template<typename Tx, typename Ty>
inline Tx mod(Tx x, Ty y)
{
    return x - y * floor(x / y);
}

struct buffer_t
{
    float4x4 u_Model;
    float4x4 u_TransposeInvModel;
    float4x4 u_VP;
    float4 u_Time;
    spvUnsafeArray<float4x4, 50> u_Palatte;
    float _Custom_Float_2;
    float _Custom_Float;
    float _Custom_Float_1;
    float4x4 u_Projection;
    float4x4 u_View;
    float4x4 u_MVP;
};

struct main0_out
{
    float3 v_posWS [[user(locn0)]];
    float3 v_nDirWS [[user(locn1)]];
    float3 v_tDirWS [[user(locn2)]];
    float3 v_bDirWS [[user(locn3)]];
    float2 v_uv0 [[user(locn4)]];
    float2 v_uv1 [[user(locn5)]];
    float4 v_color [[user(locn6)]];
    float4 gl_Position [[position]];
};

struct main0_in
{
    float3 attPosition [[attribute(0)]];
    float3 attNormal [[attribute(1)]];
    float3 attTangent [[attribute(2)]];
    float2 attTexcoord0 [[attribute(3)]];
    float2 attTexcoord1 [[attribute(4)]];
    float4 attColor [[attribute(5)]];
    float4 attBoneIds [[attribute(6)]];
    float4 attWeights [[attribute(7)]];
};

vertex main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer)
{
    main0_out out = {};
    float4x4 _422 = buffer.u_Palatte[int(in.attBoneIds.x)] * in.attWeights.x;
    float4x4 _430 = buffer.u_Palatte[int(in.attBoneIds.y)] * in.attWeights.y;
    float4x4 _451 = buffer.u_Palatte[int(in.attBoneIds.z)] * in.attWeights.z;
    float4x4 _472 = buffer.u_Palatte[int(in.attBoneIds.w)] * in.attWeights.w;
    float4x4 _485 = float4x4(((_422[0] + _430[0]) + _451[0]) + _472[0], ((_422[1] + _430[1]) + _451[1]) + _472[1], ((_422[2] + _430[2]) + _451[2]) + _472[2], ((_422[3] + _430[3]) + _451[3]) + _472[3]);
    float4 _495 = _485 * float4(in.attPosition, 1.0);
    float4 _505 = _485 * float4(in.attNormal, 0.0);
    out.v_posWS = (buffer.u_Model * float4(_495.xyz, 1.0)).xyz;
    out.v_nDirWS = float4(fast::normalize((buffer.u_TransposeInvModel * float4(_505.xyz, 0.0)).xyz), 0.0).xyz;
    float4 _526 = _485 * float4(in.attTangent, 0.0);
    out.v_tDirWS = (buffer.u_Model * float4(_526.xyz, 0.0)).xyz;
    out.v_bDirWS = cross(out.v_nDirWS, out.v_tDirWS);
    out.v_uv0 = in.attTexcoord0;
    out.v_uv1 = in.attTexcoord1;
    out.v_color = in.attColor;
    float4 _725 = buffer.u_VP * float4(out.v_posWS, 1.0);
    float2 _748 = ((_725 / float4(_725.w)).xy * 0.5) + float2(0.5);
    float2 _698 = float2(_748.x, 1.0 - _748.y) + float2(buffer.u_Time.y * buffer._Custom_Float_1);
    float2 _701 = float2(buffer._Custom_Float_2);
    float2 _779 = floor(fma(_698, _701, float2(dot(_698 * _701, float2(0.3660254180431365966796875)))));
    float2 _786 = fma(_698, _701, -_779) + float2(dot(_779, float2(0.211324870586395263671875)));
    float _788 = _786.x;
    float _790 = _786.y;
    float2 _793 = select(float2(0.0, 1.0), float2(1.0, 0.0), bool2(_788 > _790));
    float2 _797 = (_786 + float2(0.211324870586395263671875)) - _793;
    float2 _799 = _786 + float2(-0.57735025882720947265625);
    float2 _802 = mod(_779, float2(289.0));
    float3 _809 = float3(_802.y) + float3(0.0, _793.y, 1.0);
    float3 _818 = (mod(((_809 * 34.0) + float3(1.0)) * _809, float3(289.0)) + float3(_802.x)) + float3(0.0, _793.x, 1.0);
    float3 _833 = fast::max(float3(0.5) - float3(dot(_786, _786), dot(_797, _797), dot(_799, _799)), float3(0.0));
    float3 _836 = _833 * _833;
    float3 _843 = fract(mod(((_818 * 34.0) + float3(1.0)) * _818, float3(289.0)) * float3(0.024390242993831634521484375)) * 2.0;
    float3 _845 = _843 - float3(1.0);
    float3 _849 = abs(_845) - float3(0.5);
    float3 _856 = _845 - floor(_843 + float3(-0.5));
    out.v_posWS += (fast::normalize(out.v_nDirWS) * (fma(dot((_836 * _836) * (float3(1.792842864990234375) - (fma(_856, _856, _849 * _849) * 0.8537347316741943359375)), float3(fma(_856.x, _788, _849.x * _790), fma(_856.yz, float2(_797.x, _799.x), _849.yz * float2(_797.y, _799.y)))), 65.0, 0.5) * buffer._Custom_Float));
    out.v_bDirWS = cross(out.v_nDirWS, out.v_tDirWS);
    out.gl_Position = ((buffer.u_Projection * buffer.u_View) * float4(out.v_posWS, 1.0)) + (buffer.u_MVP * float4(0.0));
    out.gl_Position.z = (out.gl_Position.z + out.gl_Position.w) * 0.5;       // Adjust clip-space for Metal
    return out;
}

