#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

// Implementation of the GLSL mod() function, which is slightly different than Metal fmod()
template<typename Tx, typename Ty>
inline Tx mod(Tx x, Ty y)
{
    return x - y * floor(x / y);
}

struct buffer_t
{
    float4x4 u_Model;
    float4x4 u_TransposeInvModel;
    float4x4 u_VP;
    float4 u_Time;
    float4x4 u_MVP;
    float _Custom_Float_2;
    float _Custom_Float;
    float _Custom_Float_1;
    float4x4 u_Projection;
    float4x4 u_View;
};

struct main0_out
{
    float3 v_posWS [[user(locn0)]];
    float3 v_nDirWS [[user(locn1)]];
    float3 v_tDirWS [[user(locn2)]];
    float3 v_bDirWS [[user(locn3)]];
    float2 v_uv0 [[user(locn4)]];
    float2 v_uv1 [[user(locn5)]];
    float4 v_color [[user(locn6)]];
    float4 gl_Position [[position]];
};

struct main0_in
{
    float3 attPosition [[attribute(0)]];
    float3 attNormal [[attribute(1)]];
    float3 attTangent [[attribute(2)]];
    float2 attTexcoord0 [[attribute(3)]];
    float2 attTexcoord1 [[attribute(4)]];
    float4 attColor [[attribute(5)]];
};

vertex main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer)
{
    main0_out out = {};
    out.v_uv0 = in.attTexcoord0;
    out.v_uv1 = in.attTexcoord1;
    out.v_posWS = (buffer.u_Model * float4(in.attPosition, 1.0)).xyz;
    out.v_nDirWS = float4(fast::normalize((buffer.u_TransposeInvModel * float4(in.attNormal, 0.0)).xyz), 0.0).xyz;
    out.v_tDirWS = (buffer.u_Model * float4(in.attTangent, 0.0)).xyz;
    out.v_bDirWS = cross(out.v_nDirWS, out.v_tDirWS);
    out.v_color = in.attColor;
    float4 _620 = buffer.u_VP * float4(out.v_posWS, 1.0);
    float2 _643 = ((_620 / float4(_620.w)).xy * 0.5) + float2(0.5);
    float2 _593 = float2(_643.x, 1.0 - _643.y) + float2(buffer.u_Time.y * buffer._Custom_Float_1);
    float2 _596 = float2(buffer._Custom_Float_2);
    float2 _674 = floor(fma(_593, _596, float2(dot(_593 * _596, float2(0.3660254180431365966796875)))));
    float2 _681 = fma(_593, _596, -_674) + float2(dot(_674, float2(0.211324870586395263671875)));
    float _683 = _681.x;
    float _685 = _681.y;
    float2 _688 = select(float2(0.0, 1.0), float2(1.0, 0.0), bool2(_683 > _685));
    float2 _692 = (_681 + float2(0.211324870586395263671875)) - _688;
    float2 _694 = _681 + float2(-0.57735025882720947265625);
    float2 _697 = mod(_674, float2(289.0));
    float3 _704 = float3(_697.y) + float3(0.0, _688.y, 1.0);
    float3 _713 = (mod(((_704 * 34.0) + float3(1.0)) * _704, float3(289.0)) + float3(_697.x)) + float3(0.0, _688.x, 1.0);
    float3 _728 = fast::max(float3(0.5) - float3(dot(_681, _681), dot(_692, _692), dot(_694, _694)), float3(0.0));
    float3 _731 = _728 * _728;
    float3 _738 = fract(mod(((_713 * 34.0) + float3(1.0)) * _713, float3(289.0)) * float3(0.024390242993831634521484375)) * 2.0;
    float3 _740 = _738 - float3(1.0);
    float3 _744 = abs(_740) - float3(0.5);
    float3 _751 = _740 - floor(_738 + float3(-0.5));
    out.v_posWS += (fast::normalize(out.v_nDirWS) * (fma(dot((_731 * _731) * (float3(1.792842864990234375) - (fma(_751, _751, _744 * _744) * 0.8537347316741943359375)), float3(fma(_751.x, _683, _744.x * _685), fma(_751.yz, float2(_692.x, _694.x), _744.yz * float2(_692.y, _694.y)))), 65.0, 0.5) * buffer._Custom_Float));
    out.v_bDirWS = cross(out.v_nDirWS, out.v_tDirWS);
    out.gl_Position = ((buffer.u_Projection * buffer.u_View) * float4(out.v_posWS, 1.0)) + (buffer.u_MVP * float4(0.0));
    out.gl_Position.z = (out.gl_Position.z + out.gl_Position.w) * 0.5;       // Adjust clip-space for Metal
    return out;
}

